// Kill Stuff
AddDamageType("AAIACR",   '<bitmap:add-ons/Weapon_Package_HK/Weapons/Assault Rifles/CI_AK47> %1',    '%2 <bitmap:add-ons/Weapon_Package_HK/Weapons/Assault Rifles/CI_AAIACR> %1',0.75,1);

// Item Data
datablock ItemData(AAIACRItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// AK47 Item Properties
	shapeFile = "./AAIACR.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "A+: AAI ACR";
	iconName = "./Icon_AK47";
	doColorShift = true;
	colorShiftColor = "0.53 0.515 0.53 1";

	 // Dynamic properties defined by the scripts
	image = AAIACRImage;
	canDrop = true;

	RYG_Reloads = 1;		// This weapon can reload!
	RYG_ClipSize = 42;		// Max clip size for this weapon.
	
	// Weapon description for guis or w/e.
	RYG_Description = "Flechette rifle firing incredibly fast three-round bursts.";
};

// Weapon Image
datablock ShapeBaseImageData(AAIACRImage)
{
	shapeFile = "./AAIACR.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

    // Projectile && Ammo.
    item = AAIACRItem;
	ammo = " ";
    projectile = gunProjectile;
    projectileType = Projectile;

    casing = GunShellDebris;
    shellExitDir        = "1.0 0.1 1.0";
    shellExitOffset     = "0 0 0";
    shellExitVariance   = 10.0;	
    shellVelocity       = 5.0;

    //melee particles shoot from eye node for consistancy
    melee = false;
    //raise your arm up or not
    armReady = true;
	
	doColorShift = true;
    colorShiftColor = AAIACRItem.colorShiftColor; 

	// Rykuta's stuffings.
	RYG_Support = 1;
	
	RYG_Accuracy = 0.00001;	// First bullet's accuracy.
	RYG_RecoilAdd = 0.00018;	// Amount of spread added per shot under time.
	RYG_RecoilSub = 0.004;	// Amount of spread reduced when gun has stopped spam firing.
	RYG_RecoilTick = 320;	// Delay between each shot required for the recoil to be reduced.
	RYG_MovementPer = 180;	// Percent of recoil generated due to movement.
	RYG_MaxRecoil = 0.0045;	// Maximum recoil can reach.
	RYG_Oversight = 0.0046;	// Animation becomes more aggressive after this recoil is reached.
	
	RYG_MaxDmg = 10;		// Max damage at optimum Range.
	RYG_MinDmg = 6;		// Min damage at worst range.
	RYG_FalloffMax = 200;	// Range when bullet is at lowest damage. (In TorqueUnits)
	RYG_FalloffMin = 80;	// Range before bullet starts to lose damage. (In TorqueUnits)
	RYG_Headshot = 2.0;		// Multiplier for head damage.
	
	RYG_Bipod = 0;			// Gives the weapon the ability to utilize a bipod.
	
	RYG_BoltSound = ARBoltSound;			// Sound name for bolt pull.
	RYG_ClipInSound = MPInSound;			// Clip In Sound Name.
	RYG_ClipOutSound = LMGOutSound;			// Clip Out Sound Name.
   
    // Images have a state system which controls how the animations
    // are run, which sounds are played, script callbacks, etc. This
    // state system is downloaded to the client so that clients can
    // predict state changes and animate accordingly.  The following
    // system supports Gun ready->fire->reload transitions as
    // well as a no-ammo->dryfire idle state.
    raycastWeaponRange = 200; //varies
	raycastWeaponTargets =
        $TypeMasks::PlayerObjectType |    //AI/Players
        $TypeMasks::StaticObjectType |    //Static Shapes
        $TypeMasks::TerrainObjectType |    //Terrain
        $TypeMasks::VehicleObjectType |    //Terrain
        $TypeMasks::FXBrickObjectType;    //Bricks
    raycastExplosionProjectile = GunProjectile;
    raycastExplosionBrickSound = bulletHitSound;
    raycastExplosionPlayerSound = bulletHitSound;
    raycastDirectDamage = 1;
    raycastDirectDamageType = $DamageType::AAIACR;
    raycastSpreadAmt = 0.001; //varies
    raycastSpreadCount = 1;
    raycastTracerProjectile = SupressedTracerProjectile;
    raycastFromMuzzle = true;
    raycastImpactImulse = 10;
   

	// Main gun functionality  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "MedDrawSound";
	StateScript[0]						= "onMount";
	
	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "FireLoadCheckA";
	stateTimeoutValue[2]            	= 0.001;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEmitter[2]						= gunFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateWaitForTimeout[2]				= true;
	stateEjectShell[2]       	  		= true;
	StateSequence[2]					= "fire";
	stateSound[2]						= AR_shotCSound;
	
	stateName[4]                    	= "FireB";
	stateTransitionOnTimeout[4]     	= "FireLoadCheckC";
	stateTimeoutValue[4]            	= 0.001;
	stateFire[4]                    	= true;
	stateAllowImageChange[4]        	= false;
	stateSequence[4]                	= "fire";
	stateScript[4]                  	= "onFire";
	stateEmitter[4]						= gunFlashEmitter;
	stateEmitterTime[4]					= 0.05;
	stateEmitterNode[4]					= "muzzleNode";
	stateWaitForTimeout[4]				= true;
	stateEjectShell[4]       	  		= true;
	StateSequence[4]					= "fire";
	stateSound[4]						= AR_shotCSound;
	
	stateName[20]                    	= "FireC";
	stateTransitionOnTimeout[20]     	= "Smoke";
	stateTimeoutValue[20]            	= 0.14;
	stateFire[20]                    	= true;
	stateAllowImageChange[20]        	= false;
	stateSequence[20]                	= "fire";
	stateScript[20]                  	= "onFire";
	stateEmitter[20]					= gunFlashEmitter;
	stateEmitterTime[20]				= 0.05;
	stateEmitterNode[20]				= "muzzleNode";
	stateWaitForTimeout[20]				= true;
	stateEjectShell[20]       	  		= true;
	StateSequence[20]					= "fire";
	stateSound[20]						= AR_shotCSound;

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= gunSmokeEmitter;
	stateEmitterTime[3]					= 0.3;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]				= 0.01;
	stateTransitionOnTimeout[3]			= "LoadCheckA";

	// Reload checks  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[6]						= "LoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTimeoutValue[6]				= 0.005;
	stateTransitionOnTimeout[6]			= "LoadCheckB";
	
	stateName[7]						= "LoadCheckB";
	stateTransitionOnAmmo[7]			= "Ready";
	stateTransitionOnNoAmmo[7]			= "NoRoundsLeftA";
	
	stateName[5]						= "FireLoadCheckA";
	stateScript[5]						= "onLoadCheck";
	stateTimeoutValue[5]				= 0.005;
	stateTransitionOnTimeout[5]			= "FireLoadCheckB";
	
	stateName[8]						= "FireLoadCheckB";
	stateTransitionOnAmmo[8]			= "FireB";
	stateTransitionOnNoAmmo[8]			= "NoRoundsLeftA";
	
	stateName[18]						= "FireLoadCheckC";
	stateScript[18]						= "onLoadCheck";
	stateTimeoutValue[18]				= 0.005;
	stateTransitionOnTimeout[18]		= "FireLoadCheckD";
	
	stateName[19]						= "FireLoadCheckD";
	stateTransitionOnAmmo[19]			= "FireC";
	stateTransitionOnNoAmmo[19]			= "NoRoundsLeftA";
	
	// No Rounds Left States - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[9]						= "NoRoundsLeftA";
	stateScript[9]						= "NoRoundsLeft";
	stateTimeoutValue[9]				= 0.01;
	stateTransitionOnTimeout[9]			= "NoRoundsLeftB";
	
	stateName[10]						= "NoRoundsLeftB";
	stateTimeoutValue[10]				= 0.01;
	stateTransitionOnNoAmmo[10]			= "ReloadFull";
	stateTransitionOnTriggerDown[10]	= "NoRoundsLeftC";
	
	stateName[11]						= "NoRoundsLeftC";
	stateScript[11]						= "BlankFire";
	stateTimeoutValue[11]				= 0.01;
	stateTransitionOnTriggerUp[11]		= "NoRoundsLeftB";
	
	// Reloads - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	// Regular Reload
	stateName[12]						= "Reload";
	stateScript[12]						= "OnClipRemoved";
	stateTimeoutValue[12]				= 0.6;
	stateTransitionOnTimeout[12]     	= "InsertClipA";
	stateWaitForTimeout[12]				= true;
	StateSequence[12]					= "reload";
	
	stateName[13]						= "InsertClipA";
	stateScript[13]						= "OnClipInserted";
	stateTimeoutValue[13]				= 0.6;
	stateTransitionOnTimeout[13]     	= "ReloadFinish";
	stateWaitForTimeout[13]				= true;

	// Full Reload
	stateName[14]						= "ReloadFull";
	stateScript[14]						= "OnClipRemoved";
	stateTimeoutValue[14]				= 0.65;
	stateTransitionOnTimeout[14]     	= "InsertClipB";
	stateWaitForTimeout[14]				= true;

	stateName[15]						= "InsertClipB";
	stateScript[15]						= "OnClipInserted";
	stateTimeoutValue[15]				= 0.6;
	stateTransitionOnTimeout[15]     	= "GunBolt";
	stateWaitForTimeout[15]				= true;

	stateName[16]						= "GunBolt";
	stateScript[16]						= "onGunBolt";
	stateTimeoutValue[16]				= 0.55;
	stateTransitionOnTimeout[16]     	= "ReloadFinish";
	stateWaitForTimeout[16]				= true;

	// Finish reloading
	stateName[17]						= "ReloadFinish";
	stateScript[17]						= "OnGunReloadFinished";
	stateTimeoutValue[17]				= 0.01;
	stateTransitionOnTimeout[17]     	= "Ready";
	stateWaitForTimeout[17]				= true;
};