// Kill Stuff
AddDamageType("Chauchat",   '<bitmap:add-ons/Weapon_Package_HK/Weapons/Light Machine Guns/CI_Chauchat> %1',    '%2 <bitmap:add-ons/Weapon_Package_HK/Weapons/Light Machine Guns/CI_Chauchat> %1',0.75,1);

// Item Data
datablock ItemData(ChauchatItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// Chauchat Item Properties
	shapeFile = "./Chauchat.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "A+: Chauchat";
	iconName = "./Icon_Chauchat";
	doColorShift = true;
	colorShiftColor = "0.48 0.39 0.3 1";

	 // Dynamic properties defined by the scripts
	image = ChauchatImage;
	canDrop = true;

	RYG_Reloads = 1;		// This weapon can reload!
	RYG_ClipSize = 25;		// Max clip size for this weapon.
	RYG_NoExtraBullet = 1;
	
	// Weapon description for guis or w/e.
	RYG_Description = "A large, WWI-era portable machine gun with a very slow rate of fire.";
};

// Weapon Image
datablock ShapeBaseImageData(ChauchatImage)
{
	// Chauchat Image properties
	shapeFile = "./Chauchat.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

    // Projectile && Ammo.
    item = ChauchatItem;
	ammo = " ";
    projectile = gunProjectile;
    projectileType = Projectile;

    casing = GunShellDebris;
    shellExitDir        = "1.0 0.1 1.0";
    shellExitOffset     = "0 0 0";
    shellExitVariance   = 10.0;	
    shellVelocity       = 5.0;

    //melee particles shoot from eye node for consistancy
    melee = false;
    //raise your arm up or not
    armReady = true;
	
	doColorShift = true;
    colorShiftColor = ChauchatItem.colorShiftColor; 

	// Rykuta's stuffings.
	RYG_Support = 1;
	
	RYG_Accuracy = 0.0004;	// First bullet's accuracy.
	RYG_RecoilAdd = 0.0007;	// Amount of spread added per shot under time.
	RYG_RecoilSub = 0.002;	// Amount of spread reduced when gun has stopped spam firing.
	RYG_RecoilTick = 290;	// Delay between each shot required for the recoil to be reduced.
	RYG_MovementPer = 200;	// Percent of recoil generated due to movement.
	RYG_MaxRecoil = 0.0065;	// Maximum recoil can reach.
	RYG_Oversight = 0.0066;	// Animation becomes more aggressive after this recoil is reached.
	
	RYG_MaxDmg = 25;		// Max damage at optimum Range.
	RYG_MinDmg = 19;		// Min damage at worst range.
	RYG_FalloffMax = 200;	// Range when bullet is at lowest damage. (In TorqueUnits)
	RYG_FalloffMin = 90;	// Range before bullet starts to lose damage. (In TorqueUnits)
	RYG_Headshot = 1.6;		// Multiplier for head damage.
	
	RYG_Bipod = 1;			// Gives the weapon the ability to utilize a bipod.
	RYG_BipodPer = 25;		// Percent of recoil generated while bipod is mounted.
	
	RYG_BoltSound = SniperBoltXSound;			// Sound name for bolt pull.
	RYG_ClipInSound = LMGInSound;			// Clip In Sound Name.
	RYG_ClipOutSound = LMGOutSound;			// Clip Out Sound Name.
	RYG_IsLMG = 1;
   
    // Images have a state system which controls how the animations
    // are run, which sounds are played, script callbacks, etc. This
    // state system is downloaded to the client so that clients can
    // predict state changes and animate accordingly.  The following
    // system supports Gun ready->fire->reload transitions as
    // well as a no-ammo->dryfire idle state.
    raycastWeaponRange = 200; //varies
	raycastWeaponTargets =
        $TypeMasks::PlayerObjectType |    //AI/Players
        $TypeMasks::StaticObjectType |    //Static Shapes
        $TypeMasks::TerrainObjectType |    //Terrain
        $TypeMasks::VehicleObjectType |    //Terrain
        $TypeMasks::FXBrickObjectType;    //Bricks
    raycastExplosionProjectile = GunProjectile;
    raycastExplosionBrickSound = bulletHitSound;
    raycastExplosionPlayerSound = bulletHitSound;
    raycastDirectDamage = 0;
    raycastDirectDamageType = $DamageType::Chauchat;
    raycastSpreadAmt = 0.001; //varies
    raycastSpreadCount = 1;
    raycastTracerProjectile = TacticalBTracerProjectile;
    raycastFromMuzzle = true;
    raycastImpactImulse = 10;
   

	// Main gun functionality  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.6;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "MedDrawSound";
	StateScript[0]						= "onMount";
	
	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.2;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  		= true;
	stateEmitter[2]						= gunFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateWaitForTimeout[2]				= true;
	StateSequence[2]					= "fire";
	stateSound[2]						= M60E4FireSound;

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= gunSmokeEmitter;
	stateEmitterTime[3]					= 0.3;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]				= 0.01;
	stateTransitionOnTimeout[3]			= "LoadCheckA";

	// Reload checks  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[6]						= "LoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTimeoutValue[6]				= 0.01;
	stateTransitionOnTimeout[6]			= "LoadCheckB";
	
	stateName[7]						= "LoadCheckB";
	stateTransitionOnAmmo[7]			= "Ready";
	stateTransitionOnNoAmmo[7]			= "NoRoundsLeftA";
	
	// No Rounds Left States - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[9]						= "NoRoundsLeftA";
	stateScript[9]						= "NoRoundsLeft";
	stateTimeoutValue[9]				= 0.01;
	stateTransitionOnTimeout[9]			= "NoRoundsLeftB";
	
	stateName[10]						= "NoRoundsLeftB";
	stateTimeoutValue[10]				= 0.01;
	stateTransitionOnNoAmmo[10]			= "ReloadFull";
	stateTransitionOnTriggerDown[10]	= "NoRoundsLeftC";
	
	stateName[11]						= "NoRoundsLeftC";
	stateScript[11]						= "BlankFire";
	stateTimeoutValue[11]				= 0.01;
	stateTransitionOnTriggerUp[11]		= "NoRoundsLeftB";
	
	// Reloads - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	// Regular Reload
	stateName[20]						= "Reload";
	stateScript[20]						= "onLMGOpen";
	stateTimeoutValue[20]				= 0.25;
	stateTransitionOnTimeout[20]     	= "LMGClipOut";
	stateWaitForTimeout[20]				= true;
	
	stateName[12]						= "LMGClipOut";
	stateScript[12]						= "OnClipRemoved";
	stateTimeoutValue[12]				= 0.6;
	stateTransitionOnTimeout[12]     	= "InsertClipA";
	stateWaitForTimeout[12]				= true;
	StateSequence[12]					= "reload";
	
	stateName[13]						= "InsertClipA";
	stateScript[13]						= "OnClipInserted";
	stateTimeoutValue[13]				= 0.3;
	stateTransitionOnTimeout[13]     	= "LMGCloseA";
	stateWaitForTimeout[13]				= true;
	
	stateName[19]						= "LMGCloseA";
	stateScript[19]						= "onLMGClose";
	stateTimeoutValue[19]				= 0.25;
	stateTransitionOnTimeout[19]     	= "ReloadFinish";
	stateWaitForTimeout[19]				= true;

	// Full Reload
	stateName[21]						= "ReloadFull";
	stateScript[21]						= "onLMGOpen";
	stateTimeoutValue[21]				= 0.3;
	stateTransitionOnTimeout[21]     	= "LMGClipOutB";
	stateWaitForTimeout[21]				= true;
	
	stateName[14]						= "LMGClipOutB";
	stateScript[14]						= "OnClipRemoved";
	stateTimeoutValue[14]				= 0.6;
	stateTransitionOnTimeout[14]     	= "InsertClipB";
	stateWaitForTimeout[14]				= true;

	stateName[15]						= "InsertClipB";
	stateScript[15]						= "OnClipInserted";
	stateTimeoutValue[15]				= 0.3;
	stateTransitionOnTimeout[15]     	= "LMGCloseB";
	stateWaitForTimeout[15]				= true;
	
	stateName[18]						= "LMGCloseB";
	stateScript[18]						= "onLMGClose";
	stateTimeoutValue[18]				= 0.25;
	stateTransitionOnTimeout[18]     	= "GunBolt";
	stateWaitForTimeout[18]				= true;

	stateName[16]						= "GunBolt";
	stateScript[16]						= "onGunBolt";
	stateTimeoutValue[16]				= 0.3;
	stateTransitionOnTimeout[16]     	= "ReloadFinish";
	stateWaitForTimeout[16]				= true;

	// Finish reloading
	stateName[17]						= "ReloadFinish";
	stateScript[17]						= "OnGunReloadFinished";
	stateTimeoutValue[17]				= 0.01;
	stateTransitionOnTimeout[17]     	= "Ready";
	stateWaitForTimeout[17]				= true;
};

package LMGS
{
function WeaponImage::onLMGOpen(%this, %obj, %slot)
{
	displayAmmo(%obj, %this);
	serverPlay3D(LMGOpenSound,%obj.getPosition());
	%obj.playThread(2, shiftRight);
}

function WeaponImage::onLMGClose(%this, %obj, %slot)
{
	displayAmmo(%obj, %this);
	serverPlay3D(LMGCloseSound,%obj.getPosition());
	%obj.playThread(2, plant);
}
};
activatePackage(LMGS);