// Kill Stuff
AddDamageType("Eagle941",   '<bitmap:add-ons/Weapon_Package_HK/Weapons/Pistols/CI_Eagle941> %1',    '%2 <bitmap:add-ons/Weapon_Package_HK/Weapons/Pistols/CI_Eagle941> %1',0.75,1);

// Item Data
datablock ItemData(Eagle941Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// Eagle941 Item Properties
	shapeFile = "./Eagle941.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "A+: Eagle-941";
	iconName = "./Icon_Eagle941";
	doColorShift = true;
	colorShiftColor = "0.32 0.32 0.32 1";

	 // Dynamic properties defined by the scripts
	image = Eagle941Image;
	canDrop = true;

	RYG_Reloads = 1;		// This weapon can reload!
	RYG_ClipSize = 16;		// Max clip size for this weapon.
	
	// Weapon description for guis or w/e.
	RYG_Description = "A pistol with good handling and fire rate.";
};

// Weapon Image
datablock ShapeBaseImageData(Eagle941Image)
{
	// Eagle941 Image properties
	shapeFile = "./Eagle941.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

    // Projectile && Ammo.
    item = Eagle941Item;
	ammo = " ";
    projectile = gunProjectile;
    projectileType = Projectile;

    casing = GunShellDebris;
    shellExitDir        = "1.0 0.1 1.0";
    shellExitOffset     = "0 0 0";
    shellExitVariance   = 10.0;	
    shellVelocity       = 5.0;

    //melee particles shoot from eye node for consistancy
    melee = false;
    //raise your arm up or not
    armReady = true;
	
	doColorShift = true;
    colorShiftColor = Eagle941Item.colorShiftColor; 

	// Rykuta's stuffings.
	RYG_Support = 1;
	
	RYG_Accuracy = 0.00005;	// First bullet's accuracy.
	RYG_RecoilAdd = 0.0002;	// Amount of spread added per shot under time.
	RYG_RecoilSub = 0.001;	// Amount of spread reduced when gun has stopped spam firing.
	RYG_RecoilTick = 230;	// Delay between each shot required for the recoil to be reduced.
	RYG_MovementPer = 100;	// Percent of recoil generated due to movement.
	RYG_MaxRecoil = 0.002;	// Maximum recoil can reach.
	RYG_Oversight = 0.0017;	// Animation becomes more aggressive after this recoil is reached.
	
	RYG_MaxDmg = 12;		// Max damage at optimum Range.
	RYG_MinDmg = 7;			// Min damage at worst range.
	RYG_FalloffMax = 40;	// Range when bullet is at lowest damage. (In TorqueUnits)
	RYG_FalloffMin = 20;	// Range before bullet starts to lose damage. (In TorqueUnits)
	RYG_Headshot = 1.5;		// Multiplier for head damage.
	
	RYG_Bipod = 0;			// Gives the weapon the ability to utilize a bipod.
	
	RYG_BoltSound = PistolBoltSound;			// Sound name for bolt pull.
	RYG_ClipInSound = MPInSound;			// Clip In Sound Name.
	RYG_ClipOutSound = PistolOutSound;			// Clip Out Sound Name.
   
    // Images have a state system which controls how the animations
    // are run, which sounds are played, script callbacks, etc. This
    // state system is downloaded to the client so that clients can
    // predict state changes and animate accordingly.  The following
    // system supports Gun ready->fire->reload transitions as
    // well as a no-ammo->dryfire idle state.
    raycastWeaponRange = 80; //varies
	raycastWeaponTargets =
        $TypeMasks::PlayerObjectType |    //AI/Players
        $TypeMasks::StaticObjectType |    //Static Shapes
        $TypeMasks::TerrainObjectType |    //Terrain
        $TypeMasks::VehicleObjectType |    //Terrain
        $TypeMasks::FXBrickObjectType;    //Bricks
    raycastExplosionProjectile = GunProjectile;
    raycastExplosionBrickSound = bulletHitSound;
    raycastExplosionPlayerSound = bulletHitSound;
    raycastDirectDamage = 3;
    raycastDirectDamageType = $DamageType::Eagle941;
    raycastSpreadAmt = 0.00075; //varies
    raycastSpreadCount = 1;
    raycastTracerProjectile = TacticalSTracerProjectile;
    raycastFromMuzzle = true;
    raycastImpactImpulse = 10;
   

	// Main gun functionality  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.15;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "SmallDrawSound";
	StateScript[0]						= "onMount";
	
	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.07;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  		= true;
	stateEmitter[2]						= gunFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateWaitForTimeout[2]				= true;
	StateSequence[2]					= "fire";
	stateSound[2]						= PS_shotASound;

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= gunSmokeEmitter;
	stateEmitterTime[3]					= 0.2;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]				= 0.01;
	stateTransitionOnTimeout[3]			= "WaitForTriggerUp";
	
	stateName[8]						= "WaitForTriggerUp";
	stateScript[8]						= "WaitForTriggerUp";
	stateTransitionOnTriggerUp[8]		= "LoadCheckA";

	// Reload checks  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[6]						= "LoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTimeoutValue[6]				= 0.01;
	stateTransitionOnTimeout[6]			= "LoadCheckB";
	
	stateName[7]						= "LoadCheckB";
	stateTransitionOnAmmo[7]			= "Ready";
	stateTransitionOnNoAmmo[7]			= "NoRoundsLeftA";
	
	// No Rounds Left States - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[9]						= "NoRoundsLeftA";
	stateScript[9]						= "NoRoundsLeft";
	stateTimeoutValue[9]				= 0.01;
	stateTransitionOnTimeout[9]			= "NoRoundsLeftB";
	
	stateName[10]						= "NoRoundsLeftB";
	stateTimeoutValue[10]				= 0.01;
	stateTransitionOnNoAmmo[10]			= "ReloadFull";
	stateTransitionOnTriggerDown[10]	= "NoRoundsLeftC";
	
	stateName[11]						= "NoRoundsLeftC";
	stateScript[11]						= "BlankFire";
	stateTimeoutValue[11]				= 0.01;
	stateTransitionOnTriggerUp[11]		= "NoRoundsLeftB";
	
	// Reloads - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	// Regular Reload
	stateName[12]						= "Reload";
	stateScript[12]						= "OnClipRemoved";
	stateTimeoutValue[12]				= 0.85;
	stateTransitionOnTimeout[12]     	= "InsertClipA";
	stateWaitForTimeout[12]				= true;
	StateSequence[12]					= "reload";
	
	stateName[13]						= "InsertClipA";
	stateScript[13]						= "OnClipInserted";
	stateTimeoutValue[13]				= 0.6;
	stateTransitionOnTimeout[13]     	= "ReloadFinish";
	stateWaitForTimeout[13]				= true;

	// Full Reload
	stateName[14]						= "ReloadFull";
	stateScript[14]						= "OnClipRemoved";
	stateTimeoutValue[14]				= 0.75;
	stateTransitionOnTimeout[14]     	= "InsertClipB";
	stateWaitForTimeout[14]				= true;

	stateName[15]						= "InsertClipB";
	stateScript[15]						= "OnClipInserted";
	stateTimeoutValue[15]				= 0.6;
	stateTransitionOnTimeout[15]     	= "GunBolt";
	stateWaitForTimeout[15]				= true;

	stateName[16]						= "GunBolt";
	stateScript[16]						= "onGunBolt";
	stateTimeoutValue[16]				= 0.5;
	stateSequence[16]			= "Fire";
	stateTransitionOnTimeout[16]     	= "ReloadFinish";
	stateWaitForTimeout[16]				= true;

	// Finish reloading
	stateName[17]						= "ReloadFinish";
	stateScript[17]						= "OnGunReloadFinished";
	stateTimeoutValue[17]				= 0.01;
	stateTransitionOnTimeout[17]     	= "Ready";
	stateWaitForTimeout[17]				= true;
};