// Kill Stuff
AddDamageType("SuperBlackhawk",   '<bitmap:add-ons/Weapon_Package_HK/Weapons/Shotguns/CI_SuperBlackhawk> %1',    '%2 <bitmap:add-ons/Weapon_Package_HK/Weapons/Shotguns/CI_SuperBlackhawk> %1',0.75,1);

// Item Data
datablock ItemData(SuperBlackhawkItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// SuperBlackhawk Item Properties
	shapeFile = "./SuperBlackhawk.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "A+: Super Blackhawk";
	iconName = "./Icon_SuperBlackhawk";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1";

	 // Dynamic properties defined by the scripts
	image = SuperBlackhawkImage;
	canDrop = true;

	RYG_Reloads = 1;		// This weapon can reload!
	RYG_ClipSize = 6;		// Max clip size for this weapon.
	RYG_NoExtraBullet = 1;	// You can't load 7 rounds into a 6 round pistol.
	
	// Weapon description for guis or w/e.
	RYG_Description = "A big-game hunting revolver that packs a huge punch with magnum ammunition.";
};

// Weapon Image
datablock ShapeBaseImageData(SuperBlackhawkImage)
{
	// SuperBlackhawk Image properties
	shapeFile = "./SuperBlackhawk.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

    // Projectile && Ammo.
    item = SuperBlackhawkItem;
	ammo = " ";
    projectile = gunProjectile;
    projectileType = Projectile;

    casing = GunShellDebris;
    shellExitDir        = "1.0 0.1 1.0";
    shellExitOffset     = "0 0 0";
    shellExitVariance   = 10.0;	
    shellVelocity       = 5.0;

    //melee particles shoot from eye node for consistancy
    melee = false;
    //raise your arm up or not
    armReady = true;
	
	doColorShift = true;
    colorShiftColor = SuperBlackhawkItem.colorShiftColor; 

	// Rykuta's stuffings.
	RYG_Support = 1;
	
	RYG_Accuracy = 0.0002;	// First bullet's accuracy.
	RYG_RecoilAdd = 0.0012;	// Amount of spread added per shot under time.
	RYG_RecoilSub = 0.0022;	// Amount of spread reduced when gun has stopped spam firing.
	RYG_RecoilTick = 540;	// Delay between each shot required for the recoil to be reduced.
	RYG_MovementPer = 220;	// Percent of recoil generated due to movement.
	RYG_MaxRecoil = 0.006;	// Maximum recoil can reach.
	RYG_Oversight = 0;	// Animation becomes more aggressive after this recoil is reached.
	
	RYG_MaxDmg = 34;		// Max damage at optimum Range.
	RYG_MinDmg = 20;			// Min damage at worst range.
	RYG_FalloffMax = 70;	// Range when bullet is at lowest damage. (In TorqueUnits)
	RYG_FalloffMin = 25;	// Range before bullet starts to lose damage. (In TorqueUnits)
	RYG_Headshot = 2.5;	// Multiplier for head damage.
	RYG_StoppingPower = 1;

	RYG_Bipod = 0;
   
    // Images have a state system which controls how the animations
    // are run, which sounds are played, script callbacks, etc. This
    // state system is downloaded to the client so that clients can
    // predict state changes and animate accordingly.  The following
    // system supports Gun ready->fire->reload transitions as
    // well as a no-ammo->dryfire idle state.
    raycastWeaponRange = 100; //varies
	raycastWeaponTargets =
        $TypeMasks::PlayerObjectType |    //AI/Players
        $TypeMasks::StaticObjectType |    //Static Shapes
        $TypeMasks::TerrainObjectType |    //Terrain
        $TypeMasks::VehicleObjectType |    //Terrain
        $TypeMasks::FXBrickObjectType;    //Bricks
    raycastExplosionProjectile = GunProjectile;
    raycastExplosionBrickSound = bulletHitSound;
    raycastExplosionPlayerSound = bulletHitSound;
    raycastDirectDamage = 1;
    raycastDirectDamageType = $DamageType::SuperBlackhawk;
    raycastSpreadAmt = 0.00075; //varies
    raycastSpreadCount = 1;
    raycastTracerProjectile = TacticalMTracerProjectile;
    raycastFromMuzzle = true;
    raycastImpactImpulse = 10;
   

	// Main gun functionality  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "SmallDrawSound";
	StateScript[0]						= "onMount";
	
	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.3;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEmitter[2]						= gunFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateWaitForTimeout[2]				= true;
	StateSequence[2]					= "fire";
	stateSound[2]						= MAG_shotASound;

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= gunSmokeEmitter;
	stateEmitterTime[3]					= 0.2;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]				= 0.01;
	stateTransitionOnTimeout[3]			= "WaitForTriggerUp";
	
	stateName[8]						= "WaitForTriggerUp";
	stateTransitionOnTriggerUp[8]		= "FireLoadCheckA";
	
	stateName[23]						= "Pause";
	stateScript[23]						= "onPause";
	stateSequence[23]					= "Cock";
	stateSound[23]						= gunCloseSound;
	stateTimeoutValue[23]				= 0.05;
	stateWaitForTimeout[23]				= true;
	stateTransitionOnTimeout[23]     	= "Ready";

	// Reload checks  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[6]						= "LoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTimeoutValue[6]				= 0.01;
	stateTransitionOnTimeout[6]			= "LoadCheckB";
	
	stateName[7]						= "LoadCheckB";
	stateTransitionOnAmmo[7]			= "Ready";
	stateTransitionOnNoAmmo[7]			= "NoRoundsLeftA";
	
	stateName[13]						= "FireLoadCheckA";
	stateScript[13]						= "onLoadCheck";
	stateTimeoutValue[13]				= 0.01;
	stateTransitionOnTimeout[13]		= "FireLoadCheckB";
	
	stateName[15]						= "FireLoadCheckB";
	stateTransitionOnAmmo[15]			= "Pause";
	stateTransitionOnNoAmmo[15]			= "NoRoundsLeftA";
	
	
	// No Rounds Left States - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[9]						= "NoRoundsLeftA";
	stateScript[9]						= "NoRoundsLeft";
	stateTimeoutValue[9]				= 0.01;
	stateTransitionOnTimeout[9]			= "NoRoundsLeftB";
	
	stateName[10]						= "NoRoundsLeftB";
	stateTimeoutValue[10]				= 0.01;
	stateTransitionOnNoAmmo[10]			= "Reload";
	stateTransitionOnTriggerDown[10]	= "NoRoundsLeftC";
	
	stateName[11]						= "NoRoundsLeftC";
	stateScript[11]						= "BlankFire";
	stateTimeoutValue[11]				= 0.01;
	stateTransitionOnTriggerUp[11]		= "NoRoundsLeftB";
	
	// Reloads - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	// Regular Reload
	stateName[18]						= "Reload";
	stateSequence[18]					= "Fire";
	stateTransitionOnTimeout[18]				= "Reloading";
	stateTimeoutValue[18]					= 0.1;

	stateName[12]						= "Reloading";
	stateScript[12]						= "OnReloadingGun";
	stateTimeoutValue[12]				= 3.2;
	stateTransitionOnTimeout[12]     	= "ReloadFinish";
	stateWaitForTimeout[12]				= true;
	stateSound[12]						= MagnumReloadSound;

	// Finish reloading
	stateName[17]						= "ReloadFinish";
	stateScript[17]						= "OnGunReloadFinished";
	stateTimeoutValue[17]				= 0.01;
	stateTransitionOnTimeout[17]     	= "Pause";
	stateWaitForTimeout[17]				= true;
};

function SuperBlackhawkImage::OnReloadingGun(%this, %obj, %slot)
{
	%obj.schedule(100, playThread, 2, shiftLeft);
	%obj.schedule(500, playThread, 2, shiftTo);
	%obj.schedule(1600, playThread, 2, plant);
	%obj.schedule(1900, playThread, 2, shiftRight);
	%obj.schedule(2100, playThread, 2, rotcw);
}